/*
  smash, a chess engine
  Copyright (c) 2003-2006  Maurizio Sambati
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
  See LICENSE file for more info.

  written by Maurizio Sambati <sambati@cli.di.unipi.it>
  http://www.cli.di.unipi.it/~sambati
*/
#ifndef _HISTORY_H_
#define _HISTORY_H_

/*
  History class
  
  Created in 03/02/06
  Maurizio
*/

#include "board.h"
#include "eval.h"

const score_t MAX_HISTORY_VALUE = 16384;

class History
{
 public:
  History() {}
  ~History() {}

  void reset( const Board &board );
  void push_good( int ply, int depth, const Board &board, move_t move );
  score_t get( const Board &board, move_t move );

 private:
  score_t htable[PIECES_NUM*2 + 1][MAXPOS];  
};

#endif
