/*
  smash, a chess engine
  Copyright (c) 2003-2006  Maurizio Sambati
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
  See LICENSE file for more info.

  written by Maurizio Sambati <sambati@cli.di.unipi.it>
  http://www.cli.di.unipi.it/~sambati
*/
#ifndef _MOVEGEN_H_
#define _MOVEGEN_H_

/*
  Move generation unit

  Created in 28/06/2004
  Maurizio
*/

#include "smash.h"
#include "bitboard.h"
#include "move.h"
#include "board.h"

const int MAX_MOVE_SETS = MAXDEPTH;
const int MAX_PLY_MOVES = 100;
const int MAX_MOVES = MAX_MOVE_SETS * MAX_PLY_MOVES;

// bitboard moves
extern bitboard_t pawn_captures[][MAXPOS];
extern bitboard_t knight_moves[];
extern bitboard_t bishop_moves[][2][256];
extern bitboard_t rook_moves[][2][256];
extern bitboard_t king_moves[];
extern bool bb_init;

void InitMoveGen();
void GenCaptures( const Board &b, int set, move_t *moves_set[] );
void GenNonCaptures( const Board &b, int set, move_t *moves_set[] );
void GenEvasions( const Board &b, int set, move_t *moves_set[] );
void EraseInvalidMoves( Board &b, int set, move_t *moves_set[] );

#endif
