/*
  smash, a chess engine
  Copyright (c) 2003-2006  Maurizio Sambati
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
  See LICENSE file for more info.

  written by Maurizio Sambati <sambati@cli.di.unipi.it>
  http://www.cli.di.unipi.it/~sambati
*/
#ifndef _SEARCH_H_
#define _SEARCH_H_

/*
  Search functions

  Created in 16/03/2005
  Maurizio
*/

#include <iostream>

#include "smash.h"
#include "eval.h"
#include "board.h"
#include "timecontrol.h"
#include "ttable.h"
#include "killer.h"
#include "history.h"
#include "thread.h"

// C O N S T A N T S

const uint64_t TIMECHECK_NODES = 4096;


// V A R I A B L E S

//extern SearchStatistics search_statistics;

extern score_t root_score;
extern Status flags;
extern TimeControl timecontrol;
extern TTable ttable;
extern ThreadData thread_data[];


extern bool UseHistoryHeuristicInMoveOrder;
extern int NumThreads;

// F U N C T I O N S

void InitSearch();
void ResetSearch( ThreadData &td );
move_t SearchIterate();
score_t SearchRoot( score_t alpha, score_t beta, int depth, move_t &bestmove );
score_t Search( ThreadData &td, score_t alpha, score_t beta, int depth, int ply, bool exclusive = false );
score_t Quiesce( ThreadData &td, score_t alpha, score_t beta, int ply );

void DisplayPV( std::ostream &out, int depth, int nodescnt, int nps, int totaltime, move_t move );

#endif
