/*
  smash, a chess engine
  Copyright (c) 2003-2006  Maurizio Sambati
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
  See LICENSE file for more info.

  written by Maurizio Sambati <sambati@cli.di.unipi.it>
  http://www.cli.di.unipi.it/~sambati
*/
#include <cstdlib>
#include "zobrist.h"

hash_t zobrist_key[PLAYERS][PIECES_NUM][MAXPOS]; // hash value for each piece in each square
hash_t zobrist_key_ep[MAXCOL]; // en passant file hash
hash_t zobrist_key_castling[PLAYERS][2];  // castling status
hash_t zobrist_key_side;       // hash for black side

static hash_t GenRandomHash();

void InitializeZobristKey()
{
  for( int s = 0; s < PLAYERS; ++s ) {
    for( int p = 0; p < PIECES_NUM; ++p ) {
      for( int i = 0; i < MAXPOS; ++i ) {
	zobrist_key[s][p][i] = GenRandomHash();
      }
    }
  }

  for( int i = 0; i < MAXCOL; ++i ) {
    zobrist_key_ep[i] = GenRandomHash();
  }

  for( int s = 0; s < PLAYERS; ++s ) {
    for( int i = 0; i < 2; ++i ) {
      zobrist_key_castling[s][i] = GenRandomHash();
    }
  }

  zobrist_key_side = GenRandomHash();
}

static hash_t GenRandomHash()
{
  return hash_t(rand()) ^ ( hash_t(rand()) << 16 ) ^ ( hash_t(rand()) << 32 ) ^ ( hash_t(rand()) << 48 );
}
