/*
  smash, a chess engine
  Copyright (c) 2003-2006  Maurizio Sambati
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
  See LICENSE file for more info.

  written by Maurizio Sambati <sambati@cli.di.unipi.it>
  http://www.cli.di.unipi.it/~sambati
*/
#ifndef _ZOBRIST_H_
#define _ZOBRIST_H_

/*
  Zobrist's key module

  Created in 15/10/2005
  Maurizio
*/

#include "smash.h"

typedef uint64_t hash_t;

extern hash_t zobrist_key[PLAYERS][PIECES_NUM][MAXPOS];
extern hash_t zobrist_key_ep[MAXCOL];
extern hash_t zobrist_key_castling[PLAYERS][2];
extern hash_t zobrist_key_side;

void InitializeZobristKey();

#endif
